(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('ngx-bootstrap/popover'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap'), require('ngx-toastr'), require('@angular/material/snack-bar'), require('@ngx-translate/core'), require('@angular/common/http'), require('rxjs/operators'), require('rxjs'), require('moment'), require('date-fns/formatDistanceToNow'), require('date-fns/locale/es'), require('date-fns/locale/en-US'), require('@angular/platform-browser'), require('stompjs'), require('sockjs-client')) :
    typeof define === 'function' && define.amd ? define('@xdf/commons', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'ngx-bootstrap/popover', 'ngx-bootstrap/datepicker', 'ngx-bootstrap', 'ngx-toastr', '@angular/material/snack-bar', '@ngx-translate/core', '@angular/common/http', 'rxjs/operators', 'rxjs', 'moment', 'date-fns/formatDistanceToNow', 'date-fns/locale/es', 'date-fns/locale/en-US', '@angular/platform-browser', 'stompjs', 'sockjs-client'], factory) :
    (global = global || self, factory((global.xdf = global.xdf || {}, global.xdf.commons = {}), global.ng.core, global.ng.common, global.ng.forms, global['ngx-bootstrap'].popover, global['ngx-bootstrap'].datepicker, global['ngx-bootstrap'], global['ngx-toastr'], global.ng.material['snack-bar'], global['ngx-translate'].core, global.ng.common.http, global.rxjs.operators, global.rxjs, global.moment_, global['date-fns/formatDistanceToNow'], global['date-fns/locale/es'], global['date-fns/locale/en-US'], global.ng.platformBrowser, global.stompjs, global['sockjs-client']));
}(this, (function (exports, core, common, forms, popover, datepicker, ngxBootstrap, ngxToastr, snackBar, core$1, http, operators, rxjs, moment_, distanceInWordsToNow, es, en, platformBrowser, stompjs, SockJS) { 'use strict';

    distanceInWordsToNow = distanceInWordsToNow && distanceInWordsToNow.hasOwnProperty('default') ? distanceInWordsToNow['default'] : distanceInWordsToNow;
    es = es && es.hasOwnProperty('default') ? es['default'] : es;
    en = en && en.hasOwnProperty('default') ? en['default'] : en;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var HighlightDirective = /** @class */ (function () {
        function HighlightDirective(el) {
            this.el = el;
            this.searchText = undefined;
            this.caseSensitive = true;
            this.viewRendered = false;
            this.WRAPPER_TOKEN = '==--==##';
        }
        Object.defineProperty(HighlightDirective.prototype, "caseSensitivity", {
            get: function () { return this.caseSensitive ? '' : 'i'; },
            enumerable: true,
            configurable: true
        });
        HighlightDirective.prototype.ngOnChanges = function (changes) {
            this.highlightSearchText();
        };
        HighlightDirective.prototype.ngAfterViewInit = function () {
            this.highlightSearchText();
        };
        HighlightDirective.prototype.ngAfterViewChecked = function () {
            this.viewRendered = true;
        };
        HighlightDirective.prototype.highlightSearchText = function () {
            // initial ngChage call will result with null \ undefined.
            if (!this.searchText) {
                // when user deletes all text the searchText is set to '' we need to remove all marks.
                if (this.viewRendered) {
                    this.removePreviouslyMarkedTextInNode();
                }
                return;
            }
            if (this.el.nativeElement) {
                this.removePreviouslyMarkedTextInNode();
                this.markMatchedTextTokens(this.el.nativeElement);
            }
        };
        HighlightDirective.prototype.markMatchedTextTokens = function (htmlNode) {
            var _this = this;
            var _searchText = this.getSearchText();
            var searchRegex = new RegExp(_searchText, 'gm' + this.caseSensitivity);
            var _searchTextUniqueTokens = this.getUniqueTokenWrappedSearchText();
            var searchRegexUniqueTokens = new RegExp(_searchTextUniqueTokens, 'gm' + this.caseSensitivity);
            this.traverseHtmlElementsTree(htmlNode, function (e) {
                _this.traverseNodesInElement(htmlNode.childNodes, function (node) { return _this.wrapUniqueTokensAroundMatchedText(node, searchRegex); });
            });
            this.markMatchedTextAndRemoveUniqueTokens(htmlNode, searchRegexUniqueTokens);
        };
        HighlightDirective.prototype.markMatchedTextAndRemoveUniqueTokens = function (htmlNode, searchRegex) {
            var _this = this;
            if (htmlNode.innerHTML) {
                var innerHtml = htmlNode.innerHTML;
                var newHtml = innerHtml.replace(searchRegex, function (match) {
                    var wrapperLength = _this.WRAPPER_TOKEN.length;
                    var markedStr = match.substr(wrapperLength, match.length - (wrapperLength * 2));
                    return "<mark>" + markedStr + "</mark>";
                });
                htmlNode.innerHTML = newHtml;
            }
        };
        HighlightDirective.prototype.traverseNodesInElement = function (nodes, visitCallback) {
            nodes.forEach(function (node) {
                if (node.nodeType === 3) {
                    visitCallback(node);
                }
            });
        };
        HighlightDirective.prototype.wrapUniqueTokensAroundMatchedText = function (htmlNode, searchRegex) {
            var innerText = htmlNode.nodeValue;
            var newText = innerText.replace(searchRegex, this.WRAPPER_TOKEN + "$&" + this.WRAPPER_TOKEN);
            htmlNode.nodeValue = newText;
        };
        HighlightDirective.prototype.traverseHtmlElementsTree = function (currentNode, visitCallback) {
            if (currentNode) {
                visitCallback(currentNode);
            }
            /* tslint:disable:prefer-for-of */
            for (var i = 0; i < currentNode.children.length; i++) {
                var childNode = currentNode.children[i];
                this.markMatchedTextTokens(childNode);
            }
        };
        HighlightDirective.prototype.removePreviouslyMarkedTextInNode = function () {
            var node = this.el.nativeElement;
            var markingPattern = new RegExp('<mark>|<\/mark>', 'g');
            var cleanText = node.innerHTML.replace(markingPattern, '');
            node.innerHTML = cleanText;
        };
        // private highlightedNewTextInNode() {
        //   const node = this.el.nativeElement;
        //   const htmlNegativeLookaheadPattern = '(?![^<>]*>)';
        //   const searchTextPattern = this.getSearchText();
        //   const searchRegex = new RegExp(searchTextPattern + htmlNegativeLookaheadPattern, 'gmi');
        //   const markedText = node.innerHTML.replace(searchRegex, '<mark>$&</mark>');
        //   node.innerHTML = markedText;
        // }
        HighlightDirective.prototype.getSearchText = function () {
            var escapedSearchText = "" + this.escapeRegExp(this.searchText);
            var spaceToMultiMatchRegex = new RegExp(' ', 'gm' + this.caseSensitivity);
            escapedSearchText = escapedSearchText.replace(spaceToMultiMatchRegex, '|');
            return escapedSearchText;
        };
        HighlightDirective.prototype.getUniqueTokenWrappedSearchText = function () {
            var escapedSearchText = this.escapeRegExp(this.searchText);
            var spaceToMultiMatchRegex = new RegExp(' ', 'gm' + this.caseSensitivity);
            escapedSearchText = escapedSearchText.replace(spaceToMultiMatchRegex, this.WRAPPER_TOKEN + "|" + this.WRAPPER_TOKEN);
            escapedSearchText = "" + this.WRAPPER_TOKEN + escapedSearchText + this.WRAPPER_TOKEN;
            return escapedSearchText;
        };
        HighlightDirective.prototype.escapeRegExp = function (str) {
            return str.replace('/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/gi', '\\$&');
        };
        HighlightDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], HighlightDirective.prototype, "searchText", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], HighlightDirective.prototype, "caseSensitive", void 0);
        HighlightDirective = __decorate([
            core.Directive({
                selector: '[xdfHighlight]'
            }),
            __metadata("design:paramtypes", [core.ElementRef])
        ], HighlightDirective);
        return HighlightDirective;
    }());

    var INITSERVICE_OPTIONS = new core.InjectionToken('forRoot() MyService configuration.');
    var InitCommonsService = /** @class */ (function () {
        function InitCommonsService(config, translate, http) {
            this.config = config;
            this.translate = translate;
            this.http = http;
            this.definitionList = new Map();
            this.definitions = new Map();
        }
        InitCommonsService.prototype.initializeApp = function () {
            var _this = this;
            console.log('Init application');
            this.translate.setDefaultLang(this.config.language);
            return this.http.get('./assets/definitions/definitions.json').pipe(operators.map(function (data) {
                var requestList = new Array();
                data.forEach(function (element) {
                    var keys = Object.keys(element);
                    var key = keys[0];
                    var url = element[key];
                    _this.definitionList.set(key, url);
                    requestList.push(_this.http.get(url));
                });
                rxjs.forkJoin(requestList).subscribe(function (list) {
                    list.forEach(function (it) {
                        var keyName = 'name';
                        _this.definitions.set(it[keyName], it);
                    });
                });
            })).toPromise();
        };
        InitCommonsService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [INITSERVICE_OPTIONS,] }] },
            { type: core$1.TranslateService },
            { type: http.HttpClient }
        ]; };
        InitCommonsService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function InitCommonsService_Factory() { return new InitCommonsService(core.ɵɵinject(INITSERVICE_OPTIONS), core.ɵɵinject(core$1.TranslateService), core.ɵɵinject(http.HttpClient)); }, token: InitCommonsService, providedIn: "root" });
        InitCommonsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(0, core.Inject(INITSERVICE_OPTIONS)),
            __metadata("design:paramtypes", [Object, core$1.TranslateService,
                http.HttpClient])
        ], InitCommonsService);
        return InitCommonsService;
    }());

    var XdfCommonsModule = /** @class */ (function () {
        function XdfCommonsModule() {
        }
        XdfCommonsModule_1 = XdfCommonsModule;
        XdfCommonsModule.forRoot = function (options) {
            if (options === void 0) { options = null; }
            return ({
                ngModule: XdfCommonsModule_1,
                providers: [
                    {
                        provide: INITSERVICE_OPTIONS,
                        useValue: options
                    }
                ]
            });
        };
        var XdfCommonsModule_1;
        XdfCommonsModule = XdfCommonsModule_1 = __decorate([
            core.NgModule({
                declarations: [
                    HighlightDirective
                ],
                imports: [
                    forms.FormsModule,
                    common.CommonModule,
                    forms.ReactiveFormsModule,
                    core$1.TranslateModule,
                    ngxToastr.ToastrModule.forRoot(),
                    snackBar.MatSnackBarModule,
                    popover.PopoverModule.forRoot(),
                    datepicker.BsDatepickerModule.forRoot(),
                    ngxBootstrap.TimepickerModule.forRoot()
                ],
                exports: []
            })
        ], XdfCommonsModule);
        return XdfCommonsModule;
    }());

    var Pagination = /** @class */ (function () {
        function Pagination() {
        }
        return Pagination;
    }());
    var DIRECTION = {
        asc: 'asc',
        desc: 'desc'
    };
    var SortField = /** @class */ (function () {
        function SortField() {
            this.direction = DIRECTION.asc;
        }
        return SortField;
    }());

    var User = /** @class */ (function () {
        function User() {
        }
        return User;
    }());

    var AuthenticationService = /** @class */ (function () {
        function AuthenticationService() {
            if (localStorage.getItem('currentUser') && localStorage.getItem('currentUser') !== 'undefined') {
                this.currentUserSubject = new rxjs.BehaviorSubject(JSON.parse(localStorage.getItem('currentUser')));
                this.currentUser = this.currentUserSubject.asObservable();
            }
        }
        Object.defineProperty(AuthenticationService.prototype, "currentUserValue", {
            get: function () {
                return this.currentUserSubject ? this.currentUserSubject.value : undefined;
            },
            enumerable: true,
            configurable: true
        });
        AuthenticationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function AuthenticationService_Factory() { return new AuthenticationService(); }, token: AuthenticationService, providedIn: "root" });
        AuthenticationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [])
        ], AuthenticationService);
        return AuthenticationService;
    }());


    (function (NotificationType) {
        NotificationType["success"] = "success";
        NotificationType["info"] = "info";
        NotificationType["warning"] = "warning";
        NotificationType["error"] = "error";
    })(exports.NotificationType || (exports.NotificationType = {}));
    var NotificationService = /** @class */ (function () {
        function NotificationService() {
        }
        NotificationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NotificationService_Factory() { return new NotificationService(); }, token: NotificationService, providedIn: "root" });
        NotificationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], NotificationService);
        return NotificationService;
    }());

    var ToastNotificationService = /** @class */ (function () {
        function ToastNotificationService(injector, translate) {
            this.injector = injector;
            this.translate = translate;
            this.config = {
                closeButton: true,
                tapToDismiss: false,
                enableHtml: false,
                progressBar: false,
                newestOnTop: false,
                timeOut: 3000,
                positionClass: 'toast-top-right',
                extendedTimeOut: 1000,
                disableTimeOut: false,
                maxOpened: 0,
                easeTime: 300
            };
        }
        ToastNotificationService.prototype.showMessage = function (_message, _title, type) {
            if (_title === void 0) { _title = ''; }
            if (type === void 0) { type = exports.NotificationType.info; }
            var toastr = this.injector.get(ngxToastr.ToastrService);
            switch (type) {
                case exports.NotificationType.success:
                    toastr.success(_message, _title, this.config);
                    break;
                case exports.NotificationType.info:
                    toastr.info(_message, _title, this.config);
                    break;
                case exports.NotificationType.warning:
                    toastr.warning(_message, _title, this.config);
                    break;
                case exports.NotificationType.error:
                    toastr.error(_message, _title, this.config);
                    break;
            }
        };
        ToastNotificationService.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.TranslateService }
        ]; };
        ToastNotificationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ToastNotificationService_Factory() { return new ToastNotificationService(core.ɵɵinject(core.INJECTOR), core.ɵɵinject(core$1.TranslateService)); }, token: ToastNotificationService, providedIn: "root" });
        ToastNotificationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [core.Injector, core$1.TranslateService])
        ], ToastNotificationService);
        return ToastNotificationService;
    }());

    var SnackbarNotificationService = /** @class */ (function () {
        function SnackbarNotificationService(injector, translate) {
            this.injector = injector;
            this.translate = translate;
        }
        SnackbarNotificationService.prototype.showMessage = function (message, title, type) {
            if (title === void 0) { title = ''; }
            if (type === void 0) { type = exports.NotificationType.info; }
            var _snackBar = this.injector.get(snackBar.MatSnackBar);
            switch (type) {
                case exports.NotificationType.success:
                    _snackBar.open(message, 'close', {
                        duration: 2000,
                        panelClass: ['success-snackbar']
                    });
                    break;
                case exports.NotificationType.info:
                    _snackBar.open(message, 'close', {
                        duration: 2000,
                        panelClass: ['info-snackbar']
                    });
                    break;
                case exports.NotificationType.warning:
                    _snackBar.open(message, 'close', {
                        duration: 2000,
                        panelClass: ['warning-snackbar']
                    });
                    break;
                case exports.NotificationType.error:
                    _snackBar.open(message, 'close', {
                        duration: 2000
                    });
                    break;
            }
        };
        SnackbarNotificationService.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.TranslateService }
        ]; };
        SnackbarNotificationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function SnackbarNotificationService_Factory() { return new SnackbarNotificationService(core.ɵɵinject(core.INJECTOR), core.ɵɵinject(core$1.TranslateService)); }, token: SnackbarNotificationService, providedIn: "root" });
        SnackbarNotificationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [core.Injector, core$1.TranslateService])
        ], SnackbarNotificationService);
        return SnackbarNotificationService;
    }());

    var ErrorsHandler = /** @class */ (function () {
        function ErrorsHandler(notificationService, translate) {
            this.notificationService = notificationService;
            this.translate = translate;
        }
        ErrorsHandler.prototype.handleError = function (error) {
            if (!navigator.onLine) {
                // Handle offline error
                console.error('Browser Offline!');
            }
            else {
                console.error(error);
                if (error instanceof http.HttpErrorResponse) {
                    // Server or connection error happened
                    if (!navigator.onLine) {
                        // Handle offline error
                        console.error('Browser Offline!');
                    }
                    else {
                        // Handle Http Error (4xx, 5xx, ect.)
                        var messageError = error.error ? error.error : error.message;
                        this.notificationService.showMessage(messageError, this.translate.instant('title.http.error'), exports.NotificationType.error);
                    }
                }
                else {
                    this.notificationService.showMessage(error.message, 'title.not.http.error!', exports.NotificationType.error);
                    console.error(error);
                }
                // Always log the error
                // console.error(error);
            }
        };
        ErrorsHandler.ctorParameters = function () { return [
            { type: NotificationService },
            { type: core$1.TranslateService }
        ]; };
        ErrorsHandler = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [NotificationService, core$1.TranslateService])
        ], ErrorsHandler);
        return ErrorsHandler;
    }());

    var moment = moment_;
    var StringToDatePipe = /** @class */ (function () {
        function StringToDatePipe() {
        }
        StringToDatePipe.prototype.transform = function (value) {
            if (value === '' || value === null || value === undefined)
                return null;
            return moment(value).toDate();
        };
        StringToDatePipe = __decorate([
            core.Pipe({
                name: 'stringToDate'
            })
        ], StringToDatePipe);
        return StringToDatePipe;
    }());

    var StringToDateModule = /** @class */ (function () {
        function StringToDateModule() {
        }
        StringToDateModule = __decorate([
            core.NgModule({
                declarations: [
                    StringToDatePipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    StringToDatePipe
                ]
            })
        ], StringToDateModule);
        return StringToDateModule;
    }());

    var SecondsToHoursMinutesPipe = /** @class */ (function () {
        function SecondsToHoursMinutesPipe() {
        }
        SecondsToHoursMinutesPipe.prototype.transform = function (totalSeconds) {
            if (!totalSeconds) {
                return '0';
            }
            var hours = Math.floor(totalSeconds / 3600);
            var minutes = Math.floor((totalSeconds % 3600) / 60);
            var seconds = totalSeconds % 60;
            var result = minutes.toString().padStart(1, '0') + ":" + seconds.toString().padStart(2, '0');
            if (!!hours) {
                result = hours.toString() + ":" + minutes.toString().padStart(2, '0') + ":" + seconds.toString().padStart(2, '0');
            }
            return result;
        };
        SecondsToHoursMinutesPipe = __decorate([
            core.Pipe({
                name: 'secondsToHoursMinutes'
            })
        ], SecondsToHoursMinutesPipe);
        return SecondsToHoursMinutesPipe;
    }());

    var SecondsToHoursMinutesModule = /** @class */ (function () {
        function SecondsToHoursMinutesModule() {
        }
        SecondsToHoursMinutesModule = __decorate([
            core.NgModule({
                declarations: [
                    SecondsToHoursMinutesPipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    SecondsToHoursMinutesPipe
                ]
            })
        ], SecondsToHoursMinutesModule);
        return SecondsToHoursMinutesModule;
    }());

    var LocalizedDatePipe = /** @class */ (function () {
        function LocalizedDatePipe(config, translateService) {
            this.config = config;
            this.translateService = translateService;
        }
        LocalizedDatePipe.prototype.transform = function (value, pattern) {
            if (pattern === void 0) { pattern = 'mediumDate'; }
            var datePipe = new common.DatePipe(this.config.language);
            return datePipe.transform(value, pattern);
        };
        LocalizedDatePipe.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [INITSERVICE_OPTIONS,] }] },
            { type: core$1.TranslateService }
        ]; };
        LocalizedDatePipe = __decorate([
            core.Pipe({
                name: 'localizedDate', pure: false
            }),
            __param(0, core.Inject(INITSERVICE_OPTIONS)),
            __metadata("design:paramtypes", [Object, core$1.TranslateService])
        ], LocalizedDatePipe);
        return LocalizedDatePipe;
    }());

    var LocalizedDateModule = /** @class */ (function () {
        function LocalizedDateModule() {
        }
        LocalizedDateModule = __decorate([
            core.NgModule({
                declarations: [
                    LocalizedDatePipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    LocalizedDatePipe
                ]
            })
        ], LocalizedDateModule);
        return LocalizedDateModule;
    }());

    var TruncatePipe = /** @class */ (function () {
        function TruncatePipe() {
        }
        TruncatePipe.prototype.transform = function (value, limit, completeWords, ellipsis) {
            if (limit === void 0) { limit = 25; }
            if (completeWords === void 0) { completeWords = false; }
            if (ellipsis === void 0) { ellipsis = '...'; }
            if (value.length < limit)
                return "" + value.substr(0, limit);
            if (completeWords) {
                limit = value.substr(0, limit).lastIndexOf(' ');
            }
            return "" + value.substr(0, limit) + ellipsis;
        };
        TruncatePipe = __decorate([
            core.Pipe({
                name: 'truncate'
            })
        ], TruncatePipe);
        return TruncatePipe;
    }());

    var TruncateModule = /** @class */ (function () {
        function TruncateModule() {
        }
        TruncateModule = __decorate([
            core.NgModule({
                declarations: [
                    TruncatePipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    TruncatePipe
                ]
            })
        ], TruncateModule);
        return TruncateModule;
    }());

    var LeftPadPipe = /** @class */ (function () {
        function LeftPadPipe() {
        }
        LeftPadPipe.prototype.transform = function (value, size) {
            return (String('0').repeat(size) + value).substr((size * -1), size);
        };
        LeftPadPipe = __decorate([
            core.Pipe({
                name: 'leftPad'
            })
        ], LeftPadPipe);
        return LeftPadPipe;
    }());

    var LeftPadModule = /** @class */ (function () {
        function LeftPadModule() {
        }
        LeftPadModule = __decorate([
            core.NgModule({
                declarations: [
                    LeftPadPipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    LeftPadPipe
                ]
            })
        ], LeftPadModule);
        return LeftPadModule;
    }());

    var locales = {
        en: en, es: es
    };
    var DateAgoPipe = /** @class */ (function () {
        function DateAgoPipe(config) {
            var _this = this;
            this.config = config;
            this.refresher = new rxjs.Subscription();
            this.refreshNow = false;
            this.previousAgoExpression = '';
            this.refresher = rxjs.interval(5000).pipe(operators.startWith(0)).subscribe(function (_) { _this.refreshNow = true; });
        }
        DateAgoPipe.prototype.ngOnDestroy = function () {
            this.refresher.unsubscribe();
        };
        DateAgoPipe.prototype.transform = function (inputTime) {
            if (this.refreshNow) {
                this.refreshNow = false;
                var newAgoExpression = this.agoExpression(inputTime);
                this.previousAgoExpression = newAgoExpression;
                return newAgoExpression;
            }
            else {
                return this.previousAgoExpression;
            }
        };
        DateAgoPipe.prototype.agoExpression = function (inputTime) {
            var timeText = distanceInWordsToNow(inputTime, { includeSeconds: true, locale: locales[this.config.language] });
            return timeText;
        };
        DateAgoPipe.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [INITSERVICE_OPTIONS,] }] }
        ]; };
        DateAgoPipe = __decorate([
            core.Pipe({
                name: 'dateAgo', pure: false
            }),
            __param(0, core.Inject(INITSERVICE_OPTIONS)),
            __metadata("design:paramtypes", [Object])
        ], DateAgoPipe);
        return DateAgoPipe;
    }());

    var DateAgoModule = /** @class */ (function () {
        function DateAgoModule() {
        }
        DateAgoModule = __decorate([
            core.NgModule({
                declarations: [
                    DateAgoPipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    DateAgoPipe
                ]
            })
        ], DateAgoModule);
        return DateAgoModule;
    }());

    var SanitizeHTMLPipe = /** @class */ (function () {
        function SanitizeHTMLPipe(domSanitizer) {
            this.domSanitizer = domSanitizer;
        }
        SanitizeHTMLPipe.prototype.transform = function (html) {
            return this.domSanitizer.bypassSecurityTrustHtml(html);
        };
        SanitizeHTMLPipe.ctorParameters = function () { return [
            { type: platformBrowser.DomSanitizer }
        ]; };
        SanitizeHTMLPipe = __decorate([
            core.Pipe({ name: 'sanitizeHTML' }),
            __metadata("design:paramtypes", [platformBrowser.DomSanitizer])
        ], SanitizeHTMLPipe);
        return SanitizeHTMLPipe;
    }());

    var SanitizeHTMLModule = /** @class */ (function () {
        function SanitizeHTMLModule() {
        }
        SanitizeHTMLModule = __decorate([
            core.NgModule({
                declarations: [
                    SanitizeHTMLPipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    SanitizeHTMLPipe
                ]
            })
        ], SanitizeHTMLModule);
        return SanitizeHTMLModule;
    }());

    var SanitizeStylePipe = /** @class */ (function () {
        function SanitizeStylePipe(domSanitizer) {
            this.domSanitizer = domSanitizer;
        }
        SanitizeStylePipe.prototype.transform = function (css) {
            return this.domSanitizer.bypassSecurityTrustStyle(css);
        };
        SanitizeStylePipe.ctorParameters = function () { return [
            { type: platformBrowser.DomSanitizer }
        ]; };
        SanitizeStylePipe = __decorate([
            core.Pipe({ name: 'sanitizeStyle' }),
            __metadata("design:paramtypes", [platformBrowser.DomSanitizer])
        ], SanitizeStylePipe);
        return SanitizeStylePipe;
    }());

    var SanitizeStyleModule = /** @class */ (function () {
        function SanitizeStyleModule() {
        }
        SanitizeStyleModule = __decorate([
            core.NgModule({
                declarations: [
                    SanitizeStylePipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    SanitizeStylePipe
                ]
            })
        ], SanitizeStyleModule);
        return SanitizeStyleModule;
    }());

    var BooleanToStringPipe = /** @class */ (function () {
        function BooleanToStringPipe() {
        }
        BooleanToStringPipe.prototype.transform = function (value) {
            if (value)
                return "label.boolean.true";
            return "label.boolean.false";
        };
        BooleanToStringPipe = __decorate([
            core.Pipe({
                name: 'booleanToString'
            })
        ], BooleanToStringPipe);
        return BooleanToStringPipe;
    }());

    var BooleanToStringModule = /** @class */ (function () {
        function BooleanToStringModule() {
        }
        BooleanToStringModule = __decorate([
            core.NgModule({
                declarations: [
                    BooleanToStringPipe
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    BooleanToStringPipe
                ]
            })
        ], BooleanToStringModule);
        return BooleanToStringModule;
    }());

    var WebSocketAPI = /** @class */ (function () {
        function WebSocketAPI(socketMessageReceive, topic, webSocketEndPoint, zone) {
            if (webSocketEndPoint === void 0) { webSocketEndPoint = 'http://localhost:7070/ws'; }
            this.zone = zone;
            this.topic = topic;
            this.socketMessageReceive = socketMessageReceive;
            this.webSocketEndPoint = webSocketEndPoint;
        }
        WebSocketAPI.prototype._connect = function () {
            var _this = this;
            var ws = new SockJS(this.webSocketEndPoint);
            this.stompClient = stompjs.over(ws);
            // remove console log
            this.stompClient.debug = null;
            var THIS = this;
            THIS.stompClient.connect({}, function (frame) {
                THIS.stompClient.subscribe(THIS.topic, function (event) {
                    _this.zone.run(function () {
                        THIS.socketMessageReceive.onMessageReceived(JSON.parse(event.body));
                    });
                });
            }, this.errorCallBack);
        };
        WebSocketAPI.prototype._disconnect = function () {
            if (this.stompClient !== null) {
                this.stompClient.disconnect();
            }
            console.log('Disconnected');
        };
        WebSocketAPI.prototype.errorCallBack = function (error) {
            var _this = this;
            console.log('errorCallBack -> ' + error);
            setTimeout(function () {
                _this._connect();
            }, 5000);
        };
        WebSocketAPI.prototype._sendMessage = function (channel, message) {
            this.stompClient.send(channel, {}, JSON.stringify(message));
        };
        return WebSocketAPI;
    }());

    exports.AuthenticationService = AuthenticationService;
    exports.BooleanToStringModule = BooleanToStringModule;
    exports.BooleanToStringPipe = BooleanToStringPipe;
    exports.DIRECTION = DIRECTION;
    exports.DateAgoModule = DateAgoModule;
    exports.DateAgoPipe = DateAgoPipe;
    exports.ErrorsHandler = ErrorsHandler;
    exports.HighlightDirective = HighlightDirective;
    exports.INITSERVICE_OPTIONS = INITSERVICE_OPTIONS;
    exports.InitCommonsService = InitCommonsService;
    exports.LeftPadModule = LeftPadModule;
    exports.LeftPadPipe = LeftPadPipe;
    exports.LocalizedDateModule = LocalizedDateModule;
    exports.LocalizedDatePipe = LocalizedDatePipe;
    exports.NotificationService = NotificationService;
    exports.Pagination = Pagination;
    exports.SanitizeHTMLModule = SanitizeHTMLModule;
    exports.SanitizeHTMLPipe = SanitizeHTMLPipe;
    exports.SanitizeStyleModule = SanitizeStyleModule;
    exports.SanitizeStylePipe = SanitizeStylePipe;
    exports.SecondsToHoursMinutesModule = SecondsToHoursMinutesModule;
    exports.SecondsToHoursMinutesPipe = SecondsToHoursMinutesPipe;
    exports.SnackbarNotificationService = SnackbarNotificationService;
    exports.SortField = SortField;
    exports.StringToDateModule = StringToDateModule;
    exports.StringToDatePipe = StringToDatePipe;
    exports.ToastNotificationService = ToastNotificationService;
    exports.TruncateModule = TruncateModule;
    exports.TruncatePipe = TruncatePipe;
    exports.User = User;
    exports.WebSocketAPI = WebSocketAPI;
    exports.XdfCommonsModule = XdfCommonsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=xdf-commons.umd.js.map
