import { OnSocketMessageReceive } from './socket-message-receive';
import { NgZone } from '@angular/core';
export declare class WebSocketAPI {
    private zone;
    webSocketEndPoint: string;
    topic: string;
    stompClient: any;
    socketMessageReceive: OnSocketMessageReceive;
    constructor(socketMessageReceive: OnSocketMessageReceive, topic: string, webSocketEndPoint: string, zone: NgZone);
    _connect(): void;
    _disconnect(): void;
    errorCallBack(error: any): void;
    _sendMessage(channel: any, message: any): void;
}
