import { ExportOption } from './model/grid';
import { ColumnTemplate } from './column.template';
import { Definition } from './model/definition';
export declare class GridColumn {
    name: string;
    label: string;
    selected: boolean;
    constructor(name: string, label: string, selected?: boolean);
}
export declare class GridTemplate {
    viewID: string;
    sortColumnDefault: string;
    sortColumnDirection: any;
    pagingSize: any;
    expandRow: boolean;
    export: ExportOption[];
    definitionReport: string;
    columnTemplateArray: ColumnTemplate[];
    displayedColumns: string[];
    additionalColumns: string[];
    constructor(viewDefinition: Definition);
}
