import { Attribute } from './attribute';
import { Grid } from './grid';
import { Group } from './group';
/**
 * An object used to get page information from the server.
 * showFormInWizard: Si es true, los grupos serán mostrados en un wizard
 */
export declare class Definition {
    name: string;
    title: string;
    titleDesc: string;
    fieldToShowInActon: string;
    icon: string;
    service: string;
    recordId: string;
    showFormIn: string;
    definitionReport: string;
    grid: Grid[];
    attributes: Attribute[];
    groups: Group[];
}
