import { ErrorHandler } from '@angular/core';
import { HttpErrorResponse } from '@angular/common/http';
import { NotificationService } from '../services/notification.service';
import { TranslateService } from '@ngx-translate/core';
export declare class ErrorsHandler implements ErrorHandler {
    notificationService: NotificationService;
    private translate;
    constructor(notificationService: NotificationService, translate: TranslateService);
    handleError(error: Error | HttpErrorResponse): void;
}
