import { OnInit } from '@angular/core';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { AuthenticationService } from '@xdf/commons';
export declare class LoginComponent implements OnInit {
    private formBuilder;
    private route;
    private router;
    private authenticationService;
    loginForm: FormGroup;
    loading: boolean;
    submitted: boolean;
    returnUrl: string;
    error: string;
    constructor(formBuilder: FormBuilder, route: ActivatedRoute, router: Router, authenticationService: AuthenticationService);
    ngOnInit(): void;
    readonly f: {
        [key: string]: import("@angular/forms").AbstractControl;
    };
    onSubmit(): void;
}
