import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";

import { AeropuertoListComponent } from "./view/aeropuerto-list/aeropuerto-list.component";
import { AeropuertoRoutingModule } from "./aeropuerto-routing.module";
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TranslateModule } from '@ngx-translate/core';
import { XdfGalleryModule } from '@xdf/gallery';
import { XdfSettingsModule } from '@xdf/settings';

@NgModule({
  declarations: [
    AeropuertoListComponent
  ],
  imports: [
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    TranslateModule,
    XdfGalleryModule,
    XdfSettingsModule,
    AeropuertoRoutingModule
  ],
})
export class AeropuertoModule {}
