import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TranslateModule } from '@ngx-translate/core';
import { XdfGalleryModule } from '@xdf/gallery';
import { XdfSettingsModule } from '@xdf/settings';
import { PagoReservaRoutingModule } from './pago-reserva-routing.module';
import { PagoReservaFormComponent } from './components/pago-reserva-form/pago-reserva-form.component';
import { DatepickerSelectComponent } from '../vuelo/components/datepicker-select/datepicker-select.component';
import { MatDatepickerModule, MatTabsModule, MatTooltipModule, MatRadioModule, MatIconModule, MatButtonModule, MatDialogModule, MatProgressSpinnerModule, MatCardModule, MatSelectModule, MatCheckboxModule, MatPaginatorModule, MatGridListModule, MatChipsModule, MatListModule, MatExpansionModule, MatAutocompleteModule, MatSortModule, MatMenuModule, MatStepperModule } from '@angular/material';
import { MatInputModule } from '@angular/material/input';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatTableModule } from '@angular/material/table';
import { NgbModule, NgbPopoverModule } from '@ng-bootstrap/ng-bootstrap';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { XdfCommonsModule } from '@xdf/commons';
import { NgScrollbarModule } from 'ngx-scrollbar';
import { XdfLayoutsModule } from '@xdf/layouts';
import { DatepickerSelect2Component } from './components/datepicker-select2/datepicker-select2/datepicker-select2.component';



@NgModule({
  declarations: [
    PagoReservaFormComponent,
    DatepickerSelect2Component],
  imports: [
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    TranslateModule,
    XdfGalleryModule,
    XdfSettingsModule,
    MatTableModule,
    MatSortModule,
    MatIconModule,
    MatPaginatorModule,
    MatTooltipModule,
    MatInputModule,
    MatFormFieldModule,
    MatDialogModule,
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    XdfCommonsModule,
    XdfGalleryModule,
    TranslateModule,
    NgScrollbarModule,
    XdfLayoutsModule,
    MatSortModule,
    MatMenuModule,
    MatStepperModule,
    MatFormFieldModule,
    MatInputModule,
    ScrollingModule,
    NgbPopoverModule,
    MatChipsModule,
    MatExpansionModule,
    MatListModule,
    MatIconModule,
    MatAutocompleteModule,
    MatTableModule,
    MatExpansionModule,
    MatListModule,
    MatChipsModule,
    NgbModule,
    MatTableModule,
    MatGridListModule,
    MatPaginatorModule,
    MatCheckboxModule,
    MatSelectModule,
    MatCardModule,
    MatProgressSpinnerModule,
    MatDialogModule,
    MatButtonModule,
    MatIconModule,
    MatTableModule,
    MatRadioModule,
    MatTooltipModule,
    MatFormFieldModule,
    MatInputModule,
    MatTabsModule,
    MatDatepickerModule,
    PagoReservaRoutingModule
    
  ]
})
export class PagoReservaModule { }
