import { CollectionViewer, DataSource } from '@angular/cdk/collections';
import { Observable } from 'rxjs';
import { Pagination } from '@xdf/commons';
import { DataService } from './data.service';
export declare class DynaDataSource implements DataSource<object> {
    private service;
    private dataSubject;
    private loadingSubject;
    data: object[];
    loading$: Observable<boolean>;
    constructor(service: DataService);
    connect(collectionViewer: CollectionViewer): Observable<object[]>;
    disconnect(collectionViewer: CollectionViewer): void;
    load(pagination: Pagination): void;
}
