import { OnInit } from '@angular/core';
import { ControlType } from '../../../template/model/control-type';
import { ValidatorUtils } from '../../../utils/validator-utils';
import { FormGroupUtils } from '../../../utils/form-group-utils';
export declare class InputComponent implements OnInit {
    private formGroupUtils;
    private validatorUtils;
    name: string;
    type: ControlType;
    placeholder: string;
    suggest: string;
    disabled: boolean;
    required: boolean;
    label: string;
    options: any;
    formGroup: any;
    constructor(formGroupUtils: FormGroupUtils, validatorUtils: ValidatorUtils);
    mychange($event: any): void;
    ngOnInit(): void;
    getErrors(): any[];
}
